package com.usky.system.controller.web;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.exception.BusinessException;
import com.usky.system.controller.web.page.TableDataInfo;
import com.usky.system.domain.SysCheckCode;
import com.usky.system.domain.SysLogininfor;
import com.usky.system.mapper.SysCheckCodeMapper;
import com.usky.system.service.ISysLogininforService;
import com.usky.system.service.util.Operation;
import com.usky.system.service.vo.SysLoginExportVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.Objects;

/**
 * 系统访问记录
 *
 * @author ruoyi
 */
@RestController
@RequestMapping("/logininfor")
public class SysLogininforController extends BaseController {
    @Autowired
    private ISysLogininforService logininforService;


    @GetMapping("/list")
    public ApiResult<TableDataInfo> list(SysLogininfor logininfor) {
        startPage();
        List<SysLogininfor> list = logininforService.selectLogininforList(logininfor);
        logininforService.logCheck(list);
//        if (list.size() != 0) {
//            for (int i = 0; i < list.size(); i++) {
//                LambdaQueryWrapper<SysCheckCode> query = new LambdaQueryWrapper<>();
//                query.select(SysCheckCode::getCheckCode)
//                        .eq(SysCheckCode::getPlaintext, list.get(i).getInfoId())
//                        .eq(SysCheckCode::getCheckCodeType, 3);
//                SysCheckCode sysCheckCode = sysCheckCodeMapper.selectOne(query);
//                if (sysCheckCode == null) {
//                    throw new BusinessException("日志数据异常！");//登录日志记录有数据，而校验码表中没有数据
//                }
//                String checkCode1 = sysCheckCode.getCheckCode();
//                //分两种情况判断：dept_id参与校验码计算与否
//                try {
//                    if (!Objects.nonNull(list.get(i).getDeptId())) {
//                        String checkCode = operation.CBCMAC((list.get(i).getUserName() + list.get(i).getIpaddr() + list.get(i).getStatus() +
//                                list.get(i).getMsg() + list.get(i).getAccessTime().toString() + list.get(i).getTenantId().toString()).getBytes("UTF-8"));
//                        System.out.println("计算校验： "+checkCode);
//                        System.out.println("表中数据： "+checkCode1);
//                        if (!checkCode.equals(checkCode1)) {
//                            throw new BusinessException("【完整性】校验失败，日志数据是被破坏或者篡改的");
//                        }
//                    }else {
//                        String checkCode = operation.CBCMAC((list.get(i).getUserName() + list.get(i).getIpaddr() + list.get(i).getStatus() +
//                                list.get(i).getMsg() + list.get(i).getAccessTime().toString() + list.get(i).getDeptId().toString() + list.get(i).getTenantId().toString()).getBytes("UTF-8"));
//                        System.out.println("计算校验： "+checkCode);
//                        System.out.println("表中数据： "+checkCode1);
//                        if (!checkCode.equals(checkCode1)) {
//                            throw new BusinessException("【完整性】校验失败，日志数据是被破坏或者篡改的");
//                        }
//                    }
//                } catch (UnsupportedEncodingException e) {
//                    e.printStackTrace();
//                }
//            }
//        }
        return ApiResult.success(getDataTable(list));
    }

    @PostMapping("/listExport")
    public void export(HttpServletResponse response,
                       @RequestParam(value = "exportTitle") String exportTitle,
                       SysLogininfor logininfor) throws IOException {
        List<SysLoginExportVO> list = logininforService.selectLogininforListExport(logininfor);
        ExcelUtil<SysLoginExportVO> util = new ExcelUtil<SysLoginExportVO>(SysLoginExportVO.class);
        util.exportExcel(response, list, exportTitle, exportTitle);
    }

    @DeleteMapping("/{infoIds}")
    public ApiResult<Void> remove(@PathVariable Long[] infoIds) {
        return toAjax(logininforService.deleteLogininforByIds(infoIds));
    }


    @DeleteMapping("/clean")
    public ApiResult<Void> clean() {
        logininforService.cleanLogininfor();
        return ApiResult.success();
    }

    @PostMapping
    public ApiResult<Void> add(@RequestBody SysLogininfor logininfor) {
        logininforService.insertLogininfor(logininfor);
        return ApiResult.success();
    }
}
