package com.usky.system.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 密码服务：校验码信息表
 * </p>
 *
 * @author fu
 * @since 2024-03-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class SysCheckCode implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 自增主键ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 用户ID
     */
    private Long userId;

    /**
     * 部门ID
     */
    private Long deptId;

    /**
     * 租户ID
     */
    private Integer tenantId;

    /**
     * 敏感数据明文存储
     */
    private String plaintext;

    /**
     * 敏感数据加密存储
     */
    private String ciphertext;

    /**
     * 校验码
     */
    private String checkCode;

    /**
     * 用户名
     */
    private String userName;

    /**
     * 校验码类型（1：密码校验码；2：手机号校验码；3：登录日志校验码；4：操作日志校验码，5：文件校验码；6：签名值)
     */
    private Integer checkCodeType;

    /**
     * 验签结果（0：默认；1：验签成功：2：验签失败）
     */
    private Integer verificationResults;

    public Integer getVerificationResults() {
        return verificationResults;
    }

    public void setVerificationResults(Integer verificationResults) {
        this.verificationResults = verificationResults;
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public String getPlaintext() {
        return plaintext;
    }

    public void setPlaintext(String plaintext) {
        this.plaintext = plaintext;
    }

    public String getCiphertext() {
        return ciphertext;
    }

    public void setCiphertext(String ciphertext) {
        this.ciphertext = ciphertext;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Integer getTenantId() {
        return tenantId;
    }

    public void setTenantId(Integer tenantId) {
        this.tenantId = tenantId;
    }

    public String getCheckCode() {
        return checkCode;
    }

    public void setCheckCode(String checkCode) {
        this.checkCode = checkCode;
    }

    public Integer getCheckCodeType() {
        return checkCodeType;
    }

    public void setCheckCodeType(Integer checkCodeType) {
        this.checkCodeType = checkCodeType;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    @Override
    public String toString() {
        return "SysCheckCode{" +
                "id=" + id +
                ", deptId=" + deptId +
                ", tenantId=" + tenantId +
                ", userId=" + userId +
                ", checkCode='" + checkCode + '\'' +
                ", checkCodeType=" + checkCodeType +
                '}';
    }
}
