package com.usky.system.service.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

public class FileTools {
	public static long KBSIZE = 1024;
	public static long MBSIZE1 = 1024 * 1024;
	public static long MBSIZE10 = 1024 * 1024 * 10;
	public static long MBSIZE100 = 1024 * 1024 * 100;
	public static long MBSIZE150 = 1024 * 1024 * 150;
	public static long fileSizeLen = 0;

	public long getFileSize(String name){
		long fileSize = 0;
		File file = new File(name);
		if (file.exists()&&file.isFile()) {
			fileSize = file.length();
		}else {
			fileSize = 0;
		}
		return fileSize;
	}
	public void creatFile(String pathname,long fileLength){
		try {
			File file = new File(pathname);
			FileOutputStream fos = null;
			file.createNewFile();
			long batchSize = 0;
			batchSize = fileLength;
			if (fileLength > 1) {
				batchSize = KBSIZE;
			}
			if (fileLength > MBSIZE1) {
				batchSize = MBSIZE1;
			}
			if (fileLength > MBSIZE10) {
				batchSize = MBSIZE10;
			}if(fileLength >MBSIZE100){
				batchSize = MBSIZE100;
			}if(fileLength > MBSIZE150){
				batchSize = MBSIZE150;
			}
			long count = fileLength / batchSize;
			long last = fileLength % batchSize;
			fos = new FileOutputStream(file);
			FileChannel fileChannel = fos.getChannel();
			for (int i = 0; i < count; i++) {
				ByteBuffer buffer = ByteBuffer.allocate((int) batchSize);
				fileChannel.write(buffer);
			}
			ByteBuffer buffer = ByteBuffer.allocate((int) last);
			fileChannel.write(buffer);
			fos.close();
		} catch (IOException e) {
			new RuntimeException("creatFile error"+e.getMessage());
		}
	}
	public void reName(String oldname ,String newName){
		File oldfile = new File(oldname);
		File newfile = new File(newName);
		boolean b = oldfile.renameTo(newfile);
		if (!b) {
			b = newfile.delete();
			if (b) {
				b = oldfile.renameTo(newfile);
				if (!b) {
					new RuntimeException("file reName error:["+oldname+"] to ["+newfile+"]");
				}
			}else {
				new RuntimeException("file delete error: delete ["+newName+"]");
			}
		}
	}
	public byte[] readFileByRAF(RandomAccessFile raf, long off,int size){
		byte[] rd = new byte[size];
		try {
			raf.seek(off);
			raf.read(rd, 0,size);
		} catch (IOException e) {
			new RuntimeException("readFileByRAF error: "+e.getMessage());
		}
		return rd;
	}
	
	
	public void writFileByRAF(RandomAccessFile raf, long off,byte[] data){
		try {
			raf.seek(off);
			raf.write(data);
		} catch (IOException e) {
			new RuntimeException("writFileByRAF error"+e.getMessage());
		}
	}
}
